DECLARE FUNCTION IndexOfItemByID (IDNum AS INTEGER) AS INTEGER
'$FORM Cddiag
'$FORM MAIN
' $FORM Gamemenu
DECLARE SUB CloseTable (tableFile AS INTEGER)
DECLARE FUNCTION OpenTable () AS INTEGER
' $INCLUDE: 'UTILS.BI'
' $INCLUDE: 'DATAINC.BI'

SUB CloseTable (tableFile AS INTEGER)
    DELETEINDEX tableFile, "IDNum"
    DELETEINDEX tableFile, "ItemName"
    CLOSE tableFile
END SUB

SUB DeleteMenuItem (MenuItemID AS INTEGER)
    'delete
    DIM tableFile AS INTEGER

    tableFile = OpenTable()

    IF EOF(tableFile) THEN
          MSGBOX "No records in table, cannot delete"
          CloseTable tableFile
          EXIT SUB
    END IF

    SETINDEX tableFile, "IDNum"

    SEEKEQ tableFile, MenuItemID

    IF EOF(tableFile) THEN
        'Item not found
        MSGBOX "Unable to delete menu item, record not found"
        CloseTable tableFile
        EXIT SUB
    END IF

    DELETE tableFile  'delete the current record
    CHECKPOINT
    CloseTable tableFile

END SUB

SUB GetCategories ()

    DIM tableFile AS INTEGER
    REDIM allCategories(0) AS STRING
    DIM currentItem AS MenuItemRec

    tableFile = OpenTable()

    SETINDEX tableFile, "ItemName"  'Order results by name

    DIM i AS INTEGER
    DIM j AS INTEGER
    DIM thisCategory AS STRING
    DIM foundInCategoryList AS INTEGER
    i = 0

    anyRecs = 0
    IF NOT EOF(tableFile) THEN
        MOVEFIRST tableFile
        DO

            RETRIEVE tableFile, currentItem
            thisCategory = RTRIM$(LTRIM$(currentItem.ItemCategory))
            IF thisCategory <> "" THEN
                foundInCategoryList = 0
                FOR j = 0 TO UBOUND(allCategories)
                    IF allCategories(j) = thisCategory THEN
                        'already in
                        foundInCategoryList = -1
                    END IF
                NEXT
                IF NOT foundInCategoryList THEN
                    REDIM PRESERVE allCategories(i) AS STRING
                    allCategories(i) = thisCategory
                    i = i + 1
                END IF
            END IF

            MOVENEXT tableFile
        LOOP UNTIL EOF(tableFile)
    ELSE
        'no records
        anyRecs = 0
    END IF

    CloseTable tableFile

END SUB

SUB GetMenuItems (favoriteOnly AS INTEGER, category AS STRING)

    DIM tableFile AS INTEGER
    DIM currentItem AS MenuItemRec
    REDIM allMenuItems(0) AS MenuItemRec

    category = RTRIM$(LTRIM$(category))
    IF category = "" THEN
          category = "All"
    END IF

    tableFile = OpenTable()
    
    SETINDEX tableFile, "ItemName"  'Order results by name

    DIM i AS INTEGER
    i = 0

    anyRecs = 0
    IF NOT EOF(tableFile) THEN
        MOVEFIRST tableFile
        DO

            RETRIEVE tableFile, currentItem
            IF (NOT favoriteOnly OR currentItem.ItemIsFavorite = "T") AND (category = "All" OR RTRIM$(LTRIM$(currentItem.ItemCategory)) = category) THEN
                REDIM PRESERVE allMenuItems(i) AS MenuItemRec
                allMenuItems(i) = currentItem
                anyRecs = -1
                i = i + 1
            END IF
            MOVENEXT tableFile
        LOOP UNTIL EOF(tableFile)
    ELSE
        'no records
        anyRecs = 0
    END IF
    
    CloseTable tableFile

END SUB

SUB HandleItemSelected ()
    DIM thisFullPath AS STRING
    DIM thisDrive AS STRING
    DIM thisDirectory AS STRING
    DIM thisFile AS STRING
    DIM requiresCD AS INTEGER
    DIM thisItem AS MenuItemRec
    requiresCD = 0
    thisItem = allMenuItems(currentMenuItemIndex)

    thisFullPath = thisItem.ItemPath
    thisDrive = GetDriveFromPath(thisFullPath)
    thisDirectory = GetDirFromPath(thisFullPath)
    thisFile = GetFileFromPath(thisFullPath)
    IF thisItem.ItemCDPrompt = "T" THEN
        requiresCD = -1
    END IF
    'MSGBOX "about to load: " + thisFullPath + "|" + thisDrive + "|" + thisDirectory + "|" + thisFile
    WriteFileLoader thisDrive, thisDirectory, thisFile, requiresCD
    UNLOAD MAIN
END SUB

FUNCTION IndexOfItemByID (IDNum AS INTEGER) AS INTEGER
    IndexOfItemByID = -1
    DIM i AS INTEGER
    i = 0
    FOR i = 0 TO UBOUND(allMenuItems)
        IF allMenuItems(i).IDNum = IDNum THEN
            IndexOfItemByID = i
            EXIT FOR
        END IF
    NEXT
END FUNCTION

SUB LoadConfiguration ()
    DIM fileNum AS INTEGER
    DIM curLine AS STRING
    DIM curVar AS STRING
    DIM curVal AS STRING

    fileNum = FREEFILE
    OPEN "menu.cfg" FOR INPUT ACCESS READ AS fileNum

    DIM i AS INTEGER
    i = 0
    DO WHILE NOT EOF(fileNum)
        INPUT #fileNum, curLine
        IF INSTR(curLine, "=") > 0 THEN

            curVar = LEFT$(curLine, INSTR(curLine, "=") - 1)
            curVal = RIGHT$(curLine, LEN(curLine) - INSTR(curLine, "="))
            SELECT CASE LCASE$(curVar)
                CASE "win"
                    windowsPath = curVal
                CASE "command"
                    commandPath = curVal
                CASE "music"
                    musicPath = curVal
                CASE ELSE
                    MSGBOX "Error Reading Config, line: " + curLine
            END SELECT

        END IF
        i = i + 1
    LOOP

    CLOSE fileNum
END SUB

SUB LoadState ()
    DIM fileNum AS INTEGER
    DIM stateString AS STRING
    fileNum = FREEFILE
    OPEN "state.cfg" FOR INPUT ACCESS READ AS fileNum
    DIM fields(3) AS STRING
    DIM category AS STRING
    DIM favorite AS INTEGER
    DIM selectedID AS INTEGER
    DIM i AS INTEGER
    i = 0
    DO WHILE NOT EOF(fileNum)
        INPUT #fileNum, fields(i)
        i = i + 1
    LOOP
    
    CLOSE fileNum
    category = fields(0)
    favorite = VAL(fields(1))
    selectedID = VAL(fields(2))
    stateSelectedID = selectedID
    stateCategory = category
    stateFavorite = favorite

END SUB

SUB OpenActiveItem ()
    IF currentMenuItem.ItemCDPrompt = "T" THEN
        Cddiag.SHOW
    ELSE
        HandleItemSelected
    END IF
END SUB

FUNCTION OpenTable () AS INTEGER
    CONST TableName = "MenuItems"
    DIM menuItem AS MenuItemRec
    DIM Database AS STRING
    Database = menuDb
    MenuFile = FREEFILE

    OPEN Database FOR ISAM MenuItemRec TableName AS MenuFile
    OpenTable = MenuFile

    ON LOCAL ERROR GOTO INDEXERR
IndexCreate:

    CREATEINDEX MenuFile, "IDNum", 0, "IDNum"
    CREATEINDEX MenuFile, "ItemName", 0, "ItemName"
    GOTO FuncEnd

INDEXERR:
    RESUME NEXT
    DELETEINDEX MenuFile, "IDNum"
    DELETEINDEX MenuFile, "ItemName"
    GOTO IndexCreate

FuncEnd:

END FUNCTION

SUB RunProgram (programPath AS STRING)
    DIM drive AS STRING
    DIM path AS STRING
    DIM file AS STRING
    IF INSTR(programPath, ":\") > 0 THEN
        'Full path
        drive = GetDriveFromPath(programPath)
        path = GetDirFromPath(programPath)
        file = GetFileFromPath(programPath)
    ELSE
        'Relative to loader
        drive = GetDriveFromPath(initialPath)
        path = GetDirFromPath(initialPath)
        file = programPath
    END IF
    WriteFileLoader drive, path, file, 0
    UNLOAD MAIN
END SUB

SUB SaveMenuItem (MenuItemID AS INTEGER, menuItem AS MenuItemRec)

    DIM tableFile AS INTEGER
    DIM tempRecord AS MenuItemRec

    tableFile = OpenTable()

    SETINDEX tableFile, "IDNum"


    IF MenuItemID = -1 THEN
        'New Record
        IF EOF(tableFile) THEN
            'no records, startid at 1
            menuItem.IDNum = 1
        ELSE
            'Increment New ID to max + 1
            MOVELAST (tableFile)
            RETRIEVE tableFile, tempRecord
            menuItem.IDNum = tempRecord.IDNum + 1
        END IF
       INSERT tableFile, menuItem
       CHECKPOINT
       MenuItemID = menuItem.IDNum
    ELSE
        'Update Existing
        SEEKEQ tableFile, MenuItemID
        IF EOF(tableFile) THEN
            MSGBOX "attempted to update record that does not exist: " + STR$(MenuItemID)
        ELSE
            UPDATE tableFile, menuItem
            CHECKPOINT
        END IF
    END IF

    CloseTable tableFile

END SUB

SUB WriteFileLoader (loadDrive AS STRING, loadPath AS STRING, loadFile AS STRING, requiresCD AS INTEGER)
    DIM fileNum AS INTEGER
    fileNum = FREEFILE
    DIM returnDrive AS STRING
    DIM returnPath AS STRING
    returnDrive = GetDriveFromPath(initialPath)
    returnPath = GetDirFromPath(initialPath)

    OPEN "menuitem.bat" FOR OUTPUT ACCESS WRITE AS fileNum
    PRINT #fileNum, loadDrive + ":"
    PRINT #fileNum, "cd\" + loadPath
    PRINT #fileNum, "CALL " + loadFile
    PRINT #fileNum, returnDrive + ":"
    IF returnPath <> "" THEN
        PRINT #fileNum, "cd\" + returnPath
    END IF
    CLOSE fileNum
END SUB

SUB WriteState ()
    DIM fileNum AS INTEGER
    fileNum = FREEFILE
    OPEN "state.cfg" FOR OUTPUT ACCESS WRITE AS fileNum
    PRINT #fileNum, stateCategory + "," + STR$(stateFavorite) + "," + STR$(stateSelectedID)
    CLOSE fileNum
END SUB

